import java.io.*;
import java.util.*;

public class Baron {
  
  public static void main(String[] argv)
  throws Exception {
    
    BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
								 //new FileInputStream("example.in")));

    StringTokenizer t1 = new StringTokenizer(in.readLine());
    
    int w = Integer.parseInt(t1.nextToken());
    int h = Integer.parseInt(t1.nextToken());

    int[][] taxes = new int[w][h];

    int x=0,y=0;

    while(y<h){
      StringTokenizer t = new StringTokenizer(in.readLine());
      
      while(t.hasMoreTokens()){
	taxes[x][y] = Integer.parseInt(t.nextToken());
	x++;
	if(x==w){
	  x=0;
	  y++;
	}
      }
    }

    int bestdiff = -10000;
    int bestx=0, besty=0;

    for(int myx = 0; myx < w ; myx++)
      for(int myy=0;myy<h;myy++){
	if(taxes[myx][myy]!=0){
	  int enbestdiff=10000;

	  for(int enx = 0;enx<w;enx++)
	    for(int eny=0;eny<h;eny++)
	      if(taxes[enx][eny]!=0 && !(enx==myx && eny==myy) &&
		 distance(myx, myy, enx, eny) > 9){
		int diff = calculateTaxes(myx, myy, enx, eny, taxes, w, h);
		if(diff < enbestdiff){
		  enbestdiff = diff;
		}
	      }

	  if(enbestdiff > bestdiff){
	    bestdiff = enbestdiff;
	    bestx = myx;
	    besty = myy;
	  }
	}
      }
    
    System.out.println("Place your castle at: "+bestx+" "+besty);
  }

  static int distance(int xa, int ya, int xb, int yb){
    // return Math.abs(xa-xb)+Math.abs(ya-yb);
    return (xa-xb)*(xa-xb)+(ya-yb)*(ya-yb);
  }

  static int calculateTaxes(int myx, int myy, int enx, int eny, int[][] taxes,
			    int w, int h){
    int myTaxes=0;
    int enTaxes=0;
    
    for(int x=0;x<w;x++)
      for(int y=0;y<h;y++){
	int mydist = distance(x, y, myx, myy);
	int endist = distance(x, y, enx, eny);
	
	if(mydist < endist){
	  if(mydist <= 36)
	    myTaxes += taxes[x][y];
	} else if(endist < mydist)
	  if(endist <= 36)
	    enTaxes += taxes[x][y];
      }
    
    //System.out.println(" eval "+myx +" "+myy+" / "+enx+" "+eny+"  "+
    //	       myTaxes+"/"+enTaxes);
    return myTaxes - enTaxes;
  }
}

		  
	      

    

    
    
